import { __rest, __assign } from './../external/tslib/tslib.es6.js';
import React from 'react';
import classnames from 'classnames';
import { parseMetadata, suffixMetadata } from '@highlight-ui/utils-commons';
import { Icon } from '@highlight-ui/icon';
import styles from './Button.module.scss.js';

function ButtonWithRef(_a, ref) {
  var _b, _c, _d;

  var block = _a.block,
      _e = _a.children,
      children = _e === void 0 ? null : _e,
      className = _a.className,
      _f = _a.buttonState,
      buttonState = _f === void 0 ? 'enabled' : _f,
      metadata = _a.metadata,
      _g = _a.onClick,
      onClick = _g === void 0 ? undefined : _g,
      theme = _a.theme,
      _h = _a.variant,
      variant = _h === void 0 ? 'default' : _h,
      _j = _a.type,
      type = _j === void 0 ? 'button' : _j,
      remainingProps = __rest(_a, ["block", "children", "className", "buttonState", "metadata", "onClick", "theme", "variant", "type"]);

  var variantOrDeprecatedTheme = typeof theme !== 'undefined' ? theme : variant;
  var containerClass = classnames(styles.button, styles[variantOrDeprecatedTheme + "Button"], (_b = {}, _b[styles.block] = block, _b), (_c = {}, _c[styles.disabled] = buttonState === 'disabled' || buttonState === 'loading', _c), className);

  var focusAwareOnClick = function (event) {
    event.currentTarget.focus();
    if (onClick) onClick(event);
  };

  return /*#__PURE__*/React.createElement('button', __assign(__assign(__assign({}, remainingProps), parseMetadata(metadata)), {
    className: containerClass,
    disabled: buttonState !== 'enabled',
    onClick: focusAwareOnClick,

    /* eslint-disable react/button-has-type */
    type: type,
    ref: ref
  }), /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: classnames(styles.buttonInner, (_d = {}, _d[styles.hiddenButtonLabel] = buttonState === 'loading', _d))
  }, children && /*#__PURE__*/React.createElement("div", null, children)), buttonState === 'loading' && /*#__PURE__*/React.createElement(Icon, {
    name: "spinner-third",
    size: 16,
    spin: true,
    className: styles.loadingIcon,
    type: "solid",
    metadata: suffixMetadata(metadata, 'loading-icon')
  })));
}

ButtonWithRef.displayName = 'Button';
var Button = /*#__PURE__*/React.forwardRef(ButtonWithRef);
export { Button as default };
//# sourceMappingURL=Button.js.map
