import { __rest, __assign } from './../external/tslib/tslib.es6.js';
import React from 'react';
import classnames from 'classnames';
import { parseMetadata, suffixMetadata } from '@highlight-ui/utils-commons';
import { Icon } from '@highlight-ui/icon';
import styles from './IconButton.module.scss.js';

function IconButtonWithRef(_a, ref) {
  var _b;

  var className = _a.className,
      _c = _a.buttonState,
      buttonState = _c === void 0 ? 'enabled' : _c,
      icon = _a.icon,
      ariaLabel = _a.ariaLabel,
      metadata = _a.metadata,
      _d = _a.onClick,
      onClick = _d === void 0 ? undefined : _d,
      theme = _a.theme,
      _e = _a.variant,
      variant = _e === void 0 ? 'default' : _e,
      _f = _a.type,
      type = _f === void 0 ? 'button' : _f,
      remainingProps = __rest(_a, ["className", "buttonState", "icon", "ariaLabel", "metadata", "onClick", "theme", "variant", "type"]);

  var variantOrDeprecatedTheme = typeof theme !== 'undefined' ? theme : variant;
  var containerClass = classnames(styles.iconButton, styles[variantOrDeprecatedTheme + "Button"], (_b = {}, _b[styles.disabled] = buttonState === 'disabled', _b), className);

  var focusAwareOnClick = function (event) {
    event.currentTarget.focus();
    if (onClick) onClick(event);
  };

  return /*#__PURE__*/React.createElement('button', __assign(__assign(__assign({}, remainingProps), {
    className: containerClass,
    disabled: buttonState !== 'enabled',
    onClick: focusAwareOnClick,

    /* eslint-disable react/button-has-type */
    type: type,
    ref: ref,
    'aria-label': ariaLabel
  }), parseMetadata(metadata)), /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", null, buttonState === 'loading' ? /*#__PURE__*/React.createElement(Icon, {
    name: "spinner-third",
    size: 16,
    spin: true,
    type: "solid",
    metadata: suffixMetadata(metadata, 'loading-icon')
  }) : /*#__PURE__*/React.createElement(Icon, {
    name: icon,
    size: 14,
    type: "solid",
    metadata: suffixMetadata(metadata, 'icon')
  }))));
}

IconButtonWithRef.displayName = 'IconButton';
var IconButton = /*#__PURE__*/React.forwardRef(IconButtonWithRef);
export { IconButton as default };
//# sourceMappingURL=IconButton.js.map
